%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%% bung SS 2017
%% Digitale Signalverarbeitung (DSV)
%% Eric Elzenheimer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Audio-Datei einlesen und normalisieren
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[x,fs]=audioread('sprachsignal.wav');
x=x';               %x in einen Zeilenvektor verwandeln
x=x/max(abs(x));    %x wird jetzt auf -1 bzw. +1 normiert
figure('units','normalized','outerposition',[0.25 0.5 0.5 0.5]);
t=(0:length(x)-1)/fs;
plot(t,x)
axis([0 max(t) -1 1])
xlabel('\it{t}/s')
ylabel('x(\it{t})')
title('The orginal signal');
grid on;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Anhren der Wave - Datei
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('Das Originalsignal wird ausgegeben');
test=audioplayer(x,fs)
play(test);
pause(5);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Quantizierung mit verschiedener Bit-Auflsung
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for w=2:15
    [xq10(w-1,:),eq10(w-1,:),delta10(w-1,:),a10(w-1,:),b10(w-1,:),...
    SNR10(w-1,:)] = quantisierer(x,w);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Anzeigen der Ergebnisse
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for w=2:15
    display(['Quantisiertes Signal fr w = ', num2str(w)])
    test2=audioplayer(xq10(w-1,:),fs);
    figure('units','normalized','outerposition',[0 0.5 0.5 0.5]);
    t=(0:length(x)-1)/fs;
    plot(t,xq10(w-1,:))
    title(['Quantisiertes Signal fr w =', num2str(w)])
    xlabel('\it{t}/s')
    ylabel(['xq_',num2str(w),'(\it{t})']);
    axis([0 max(t) -1 1])
    grid on;
    play(test2);
    pause(5);
    display(['Quantisierungsgerusch Signal fr w =', num2str(w)])
    test1=audioplayer(eq10(w-1,:),fs);
    figure('units','normalized','outerposition',[0.5 0.5 0.5 0.5]);
    t=(0:length(x)-1)/fs;
    plot(t,eq10(w-1,:))
    title(['Quantisierungsgerusch fr w =', num2str(w)])
    xlabel('\it{t}/s')
    ylabel(['eq_',num2str(w),'(\it{t})']);
    axis([0 max(t) -1 1])
    grid on;
    play(test1);
    pause(5);
end