%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Funktion zur Quantisierung eines Signals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Quantisierung eines Signals 
% [xq,eq,delta,a,b,SNR] = myQuantiser(x,w) 
% xq......wertquantisiertes Signal (Vektor) 
% eq......Quantisierungsgerusch eq=x-xq (Vektor) 
% delta...Quantisierungsstufe 
% a.......Untergrenze Quantisierer 
% b.......Obergrenze Quantisierer 
% SNR.....Mittlerer Signal/Geruschabstand in dB 
% x ......Originalsignal (Vektor) 
% w ......Bits pro Sample 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [xq,eq,delta,a,b,SNR] = quantisierer(x,w)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Intialisierung der Variablen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xq=[];
eq=[];
delta=0;
a=0;
b=0;
SNR=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
q=quantizer('fixed', 'nearest','saturate', [w w-1]);
%temp=range(q);
xq=quantize(q,x);
q.noverflows;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Auslesen des quantisierers 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a=q.minlog;
b=q.maxlog;
%delta=2/2^w;
delta=eps(q);
eq=x-xq;
SNR=10*log10(sum(x.^2)/sum(eq.^2));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ausgabe der Ergebnisse
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(['w = ' , num2str(w)]);
disp(['a = ' , num2str(a)]);
disp(['b = ' , num2str(b)]);
disp(['delta = ' , num2str(delta)]);
disp(['SNR = ' , num2str(SNR)]);